<template>
	<div>
		<v-snackbar
			v-model="snackbar"
			class="subtitle-1"
			top
			right
			color="#72a051"
		>Registro exitoso, confirma el mensaje que se envío a tu correo</v-snackbar>
		<v-snackbar v-model="snackErr" class="subtitle-1" top right color="#c51f2f">{{msg}}</v-snackbar>
		<v-dialog v-model="displayForm" max-width="570" persistent>	
			<v-form ref="formRegister" v-model="isValid">
				<v-card color="grey lighten-3">
					<v-card-title class="textCenter">Registro</v-card-title>
					<v-card-text>
						<v-row>
							<v-col cols="12" sm="6">
								<v-text-field
									id="curp"
									prepend-icon="fas fa-id-card"
									label="CURP"
									:rules="rulesCURP"
									outlined
									v-model="user.curp"
									required
								/>
							</v-col>
							<v-col cols="12" sm="6">
								<v-text-field
									prepend-icon="fas fa-at"
									label="Correo electrónico"
									:rules="rulesEmail"
									outlined
									v-model="user.email"
									required
								/>
							</v-col>
						</v-row>
						<v-row>
							<v-col cols="12" sm="6">
								<v-text-field
									prepend-icon="fas fa-key"
									label="Contraseña"
									:rules="rulesPass"
									outlined
									:append-icon="showPass ? 'fa-eye-slash' : 'fa-eye'"
									:type="showPass ? 'text' : 'password'"
									@click:append="showPass = !showPass"
									v-model="user.pass"
									required
								/>
							</v-col>
							<v-col cols="12" sm="6">
								<v-text-field
									prepend-icon="fas fa-key"
									label="Confirmar contraseña"
									:rules="confirmPass"
									outlined
									:append-icon="showComparePass ? 'fa-eye-slash' : 'fa-eye'"
									:type="showComparePass ? 'text' : 'password'"
									@click:append="showComparePass = !showComparePass"
									v-model="comparePass"
									required
								/>
							</v-col>
						</v-row>
					</v-card-text>
					<v-card-actions>
						<v-btn
							:disabled="!isValid"
							rounded
							block
							color="success"
							@click="prevRegister(user)"
						>Registrarse</v-btn>
					</v-card-actions>
					<a
						class="body-1 textCenter pb-3"
						@click="closeFormRegister"
					>¿Ya tienes una cuenta? Ingresa aquí</a>
				</v-card>
			</v-form>
		</v-dialog>
	</div>
</template>

<script>
import EventBus from "../../bus";
import { mapActions } from "vuex";

export default {
	name: "FormRegister",
	props: ["displayForm"],
	data: () => ({
		blockButton: false,
		snackbar: false,
		snackErr: false,
		msg: "",
		showPass: false,
		showComparePass: false,
		comparePass: "",
		isValid: true,
		user: {
			curp: "",
			email: "",
			pass: ""
		},
		rulesPass: [
			value => !!value || "Campo requerido",
			value => (value || "").length >= 8 || "Mínimo 8 carácteres"
		],
		rulesCURP: [
			value => !!value || "Campo requerido",
			value =>
				(value || "").length === 18 || "18 carácteres obligatorios",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'",<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo letras y números";
			}
		],
		rulesEmail: [
			value => !!value || "Campo requerido",
			value => {
				const pattern = /^\w+([\.-]?\w+)*@\w+(\.com||\.com\.mx||\.mx||\.es)+$/;
				return pattern.test(value) || "Correo electrónico inválido";
			}
		]
	}),
	computed: {
		// Verifica ambas contraseñas sean correctas
		confirmPass() {
			return [
				this.user.pass === this.comparePass ||
					"Las contraseñas no coinciden"
			];
		}
	},
	watch: {
		// escucha el input curp y transforma el texto a mayusculas
		user: {
			handler(val, oldVal) {
				if (this.user.curp !== undefined) {
					this.user.curp = this.user.curp.toUpperCase();
				}
			},
			deep: true
		}
	},
	methods: {
		...mapActions(["prevRegister"]),
		// Cierra el formulario de registro
		closeFormRegister() {
			EventBus.$emit("closeFormRegister");
			this.$refs.formRegister.reset();
		}
	},
	mounted() {
		// Muesta el snackbar de registro exitoso
		EventBus.$on("responsePrevRegister", msg => {
			switch (msg) {
				case "CURP o correo existente":
					this.msg = msg;
					this.snackErr = true;
					setTimeout(() => {
						this.snackErr = false;
					}, 2000);
					break;
				case "CURP o correo repetido":
					this.msg = msg;
					this.snackErr = true;
					setTimeout(() => {
						this.snackErr = false;
					}, 2000);
					break;
				default:
					this.isValid = false;
					this.snackbar = true;
					this.blockButton = true;
					setTimeout(() => {
						this.closeFormRegister();
						this.snackbar = false;
					}, 3000);
					break;
			}
		});
		// cierra el formulario de registro con la tecla ESC
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				EventBus.$emit("closeFormRegister");
				this.$refs.formRegister.reset();
			}
		});
	}
};
</script>

<style scope>
.textCenter {
	display: flex;
	justify-content: center;
}
#curp {
	text-transform: uppercase;
}
</style>